#!/usr/bin/env python
# -*- coding: utf-8 -*-

import FreeCAD
import Mesh
import os
import sys
import glob
import PySide
from PySide import QtGui

import pythonVerCheck

doc = App.ActiveDocument
name = os.path.splitext(doc.FileName)[0]
modelDir = os.path.dirname(doc.FileName)

#モデルファイル置き場がケースファイルの場所（.CaseFileDictで指定）と異なる場合
caseFileDict = modelDir + "/.CaseFileDict"
if os.path.isfile(caseFileDict) == True:
    f = open(caseFileDict)
    modelDir = f.read()
    f.close()

os.chdir(modelDir)

systemFolder = modelDir + "/system"
constantFolder = modelDir + "/constant"

if os.path.isdir(systemFolder):

	envSet = ". ~/.FreeCAD/runTreefoamSubset\n"
	wdir = modelDir + "/system"
	title = _("edit Dict File")
	img = "oneFile"
	mess = _("select edit Dict file.\n\nDict file is in system folder.")
	editDir = wdir
	job = "editDictFile"

	# boundary File の選択と編集

	#self.showSelectFolderFilesDialog(job, title, img, mess, editDir)

	cont  = envSet + "selectFolderFilesDialog.py " + job + " '" + title + "' " + img
	cont += " '" + mess + "' " + editDir
	if sys.version_info.major == 2 : 
		cont = cont.encode('utf-8') 
	#print(cont)
	f=open("./run","w")
	f.write(cont)
	f.close()
	#実行権付与
	os.system("chmod a+x run")
	#実行
	comm = "xfce4-terminal --execute bash ./run"
	#comm= "gnome-terminal --geometry=80x15 --zoom=0.9 -- bash --rcfile ./run"
	#subprocess.call(comm .strip().split(" "))
	#os.system(comm)

	os.system(comm.encode("utf-8"))

else:
    message = (_("there is no system folder.\n  check current directory."))
    ans = QtGui.QMessageBox.critical(None, _("check OpenFOAM case"), message, QtGui.QMessageBox.Yes)

